<template>
    <v-container>
        <v-form
    ref="form"
    v-model="valid"
    lazy-validation
  >
  <v-row>
    <v-col cols="12" md="1"></v-col>
    <v-col cols="12" md="10">
    <v-row>
    <!-- имя -->
    <v-text-field
      v-model="user_name"
      :rules="requiredField"
      label="Ваше имя"
      required
      class="mr-3"
    ></v-text-field>
    <!-- телефон -->
    <v-text-field
      v-model="phone_number"
      :counter="12"
      :rules="phoneNumberRules"
      label="Номер телефона"
      required
      class="ml-3"
    ></v-text-field>
    </v-row>
    <v-row>
    <!-- бренд -->
    <v-select
      v-model="brand_name"
      :items="brands"
      :rules="[v => !!v || 'Обязательное поле']"
      label="Бренд"
      required
      class="mr-3"
    ></v-select>
    <!-- модель -->
    <v-select
      v-model="model_name"
      :items="models"
      :rules="[v => !!v || 'Обязательное поле']"
      label="Модель"
      required
      class="ml-3"
    ></v-select>
  </v-row>
  <v-row>
    <!-- название объявления -->
    <v-text-field
      v-model="title"
      :rules="requiredField"
      label="Название объявления"
      required
      class="mr-3"
    ></v-text-field>
    <!-- цена -->
    <v-text-field
      v-model="cost"
      :rules="requiredField"
      label="Цена"
      required
      class="ml-3"
    ></v-text-field>
  </v-row>
  <v-row>
    <!-- мощность -->
    <v-text-field
      v-model="engine_volume"
      :counter="4"
      :rules="engine_volumeRules"
      label="Лошадиных сил"
      required
      class="mr-3"
    ></v-text-field>
    <!-- год выпуска -->
    <v-text-field
      v-model="year_of_issue"
      :counter="4"
      :rules="year_of_issueRules"
      label="Год выпуска"
      required
      class="ml-3"
    ></v-text-field>
  </v-row>
  <v-row>
    <!-- цвет -->
    <v-text-field
      v-model="color"
      :rules="requiredField"
      label="Цвет"
      required
      class="mr-3"
    ></v-text-field>
    <!-- описание -->
    <v-text-field
      v-model="description"
      :rules="requiredField"
      label="Описание"
      required
      class="ml-3"
    ></v-text-field>
    </v-row>
    <!-- Фото -->
    <v-file-input
    v-model="photo"
    :rules="requiredField"
    label="Фото"
    required
    />
  </v-col>
    <v-col cols="12" md="1"></v-col>
  </v-row>
  <v-row>
    <v-col cols="12" md="1"></v-col>
    <v-col cols="12" md="10">
    <v-btn
      color="error"
      class="mr-4"
      @click="reset"
    >
      Очистить форму
    </v-btn>
    <v-btn class="amber lighten-1" @click="addAd">Опубликовать</v-btn>
    </v-col>
    <v-col cols="12" md="1"></v-col>
    </v-row>
  </v-form>
    </v-container>
</template>
  
  <script>
  
  export default {
    data: () => ({
        valid: true,

        user_name: '',
        requiredField: [
          v => !!v || 'Обязательное поле',
        ],
        phone_number: '',
        phoneNumberRules: [
          v => !!v || 'Обязательное поле',
          v => /\+7\d{3}\d{3}\d{2}\d{2}/.test(v) || 'Введите номер телефона правильно',
          v => (v && v.length <= 12) || 'Не больше 12 символов',
        ],
        brand_name: null,
        brands: [
            'Jeep',
            'Chevrolet',
            'Lada',
            'Reno',
            'Citroen',
            'Skoda',
            'Volksvagen',
            'Audi',
            'Porsche',
            'BMW',
        ],
        model_name: null,
        models: [
            'Cherokee',
            'Camaro',
            'Granta',
            'Duster',
            'Berlingo',
            'Octavia',
            'Polo',
            'q8',
            '911',
            '540i',
        ],
        title: '',
        cost:'',
        engine_volume:'',
        engine_volumeRules: [
          v => !!v || 'Обязательное поле',
          v => (v && v.length <= 4) || 'Не больше 4 символов',
        ],
        year_of_issue:'',
        year_of_issueRules: [
          v => !!v || 'Обязательное поле',
          v => (v && v.length <= 4) || 'Не больше 4 символов',
        ],
        color:'',
        description:'',
        photo: null,
    }),
    methods: {
        addAd() {
            const reader = new FileReader()
            reader.onload = () => {
                let car = {
                    id: Date.now(),
                    user_name: this.user_name,
                    phone_number: this.phone_number,
                    brand_name: this.brand_name,
                    model_name: this.model_name,
                    title: this.title,
                    cost: this.cost,
                    engine_volume: this.engine_volume,
                    year_of_issue: this.year_of_issue,
                    color: this.color,
                    description: this.description,
                    photo: reader.result,
                }
                this.$emit('addAd', car)
            }
            reader.readAsDataURL(this.img)
        },
        validate () {
        this.$refs.form.validate()
        },
        reset () {
          this.$refs.form.reset()
        },
        resetValidation () {
          this.$refs.form.resetValidation()
        },
    }
  };
  </script>

<style scoped>

</style>








